<?php
/**
 * @version        1.0
 * @package        Joomla
 * @subpackage     Eshop
 * @author         softpill.eu
 * @copyright      Copyright (C) 2012-2014 softpill.eu
 * @license        GNU/GPL, see LICENSE.txt
 */
class os_eshop_vcs extends os_payment
{
	public function __construct($params)
	{
		$config = array(
			'type' => 0,
			'show_card_type' => false,
			'show_card_holder_name' => false
		);
		parent::__construct($params, $config);
		$this->vcs_terminal_id = $params->get('vcs_terminal_id');
    $this->vcs_description_of_goods = $params->get('vcs_description_of_goods');
    $this->vcs_currency = $params->get('vcs_currency');
    $this->vcs_populate_payer_email = $params->get('vcs_populate_payer_email');
    $this->vcs_sms_send = $params->get('vcs_sms_send');
    $this->vcs_mobile_number = $params->get('vcs_mobile_number');
    $this->vcs_sms_message = $params->get('vcs_sms_message');
    $this->vcs_md5_salt = $params->get('vcs_md5_salt');
	}

	/**
	 * Payment processing
	 *
	 * @param array  $data
	 */
	public function processPayment($data)
	{
    $this->url = 'https://www.vcs.co.za/vvonline/vcspay.aspx';
    
		$siteUrl = JUri::root();
    $post_variables_md5 = Array(
      'p1' => $this->vcs_terminal_id,
			'p2' => $data['order_id'],
			'p3' => $this->vcs_description_of_goods.' '.$data['order_id'],
			'p4' => round($data['total'], 2),
			'p5' => $this->vcs_currency,
			'p6' => '0',			
			'p7' => '',			
			'p8' => $this->vcs_sms_send == 'Y' ? $this->vcs_mobile_number : '',			
			'p9' => $this->vcs_sms_send == 'Y' ? $this->vcs_sms_message : '',			
			'p10' => $siteUrl . 'index.php?option=com_eshop&view=checkout&layout=cancel&id=' . $data['order_id'],			
			'p11' => '',			
			'p13' => '0',			
			'NextOccurDate' => '',				
			'CardHolderEmail' => $data['email'],			
			'm_1' => '',			
			'm_2' => '',			
			'm_3' => '',			
			'm_4' => '',			
			'm_5' => '',			
			'm_6' => '',			
			'm_7' => '',			
			'm_8' => '',			
			'm_9' => '',			
			'm_10' => '');
		$hash_string = @implode('', $post_variables_md5);
		$hash_post = md5($hash_string . $this->vcs_md5_salt);
    
    $this->setData('p1', $this->vcs_terminal_id);
    $this->setData('p2', $data['order_id']);
		$this->setData('p3', $this->vcs_description_of_goods.' '.$data['order_id']);
		$this->setData('p4', round($data['total'], 2));
    $this->setData('p5', $this->vcs_currency);
    $this->setData('p6','0');			
		$this->setData('p7','');		
		$this->setData('p8',$this->vcs_sms_send == 'Y' ? $this->vcs_mobile_number : '');		
		$this->setData('p9',$this->vcs_sms_send == 'Y' ? $this->vcs_sms_message : '');		
		$this->setData('p10',$siteUrl . 'index.php?option=com_eshop&view=checkout&layout=cancel&id=' . $data['order_id']);			
		$this->setData('p11','');
    $this->setData('p12','N');			
		$this->setData('p13','0');			
		$this->setData('NextOccurDate','');				
		$this->setData('CardHolderEmail',$data['email']);			
		$this->setData('m_1','');				
		$this->setData('m_2','');			
		$this->setData('m_3','');
		$this->setData('m_4','');			
		$this->setData('m_5','');		
		$this->setData('m_6','');	
		$this->setData('m_7','');	
		$this->setData('m_8','');		
		$this->setData('m_9','');		
		$this->setData('m_10','');
  	$this->setData('URLSProvided','Y');
		$this->setData('ApprovedUrl',$siteUrl . 'index.php?option=com_eshop&task=checkout.verifyPayment&payment_method=os_eshop_vcs&oid='.$data['order_id']);			
		$this->setData('DeclinedUrl',$siteUrl . 'index.php?option=com_eshop&task=checkout.verifyPayment&payment_method=os_eshop_vcs&oid='.$data['order_id']);			
		$this->setData('Hash',$hash_post);
    
    

		$this->submitPost();
	}
	/**
	 * Process payment
	 *
	 */
	public function verifyPayment()
	{
		$ret = $this->validate();
		if ($ret)
		{
			$row = JTable::getInstance('Eshop', 'Order');
			$id     = (int) $this->getData['oid'];
			$row->load($id);
			if ($row->order_status_id == EshopHelper::getConfigValue('complete_status_id'))
			{
				return false;
			}
			$row->transaction_id = $this->getData['oid'];
			$row->order_status_id = EshopHelper::getConfigValue('complete_status_id');
			$row->store();
			EshopHelper::completeOrder($row);
			JPluginHelper::importPlugin('eshop');
			$dispatcher = JDispatcher::getInstance();
			$dispatcher->trigger('onAfterCompleteOrder', array($row));
			//Send confirmation email here
			if (EshopHelper::getConfigValue('order_alert_mail'))
			{
				EshopHelper::sendEmails($row);
			}
      //redirect
      $app=JFactory::getApplication();
      $app->redirect('/index.php?option=com_eshop&view=checkout&layout=complete');
      return true;
		}
	}

	/**
	 * Validate the post data from 2checkout to our server
	 *
	 * @return string
	 */
	protected function validate()
	{
		foreach ($_GET as $key => $value)
		{
			$this->getData[$key] = $value;
		}
		//$this->logGatewayData();
		if (isset($this->getData['p3']))
		{
      $findme   = 'APPROVED';
      $pos = strpos($this->getData['p3'], $findme);
      if ($pos === false)
      {
        return false;
      }
			return true;
		}
		else
		{
			return false;
		}
	}
}